"""
    Veeroute.LSS Field Service Engineers

    Veeroute.LSS Field Service Engineers API  # noqa: E501

    The version of the OpenAPI document: 3.8.168672
    Contact: support@veeroute.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from vrt_lss_fieldservice.api_client import ApiClient, Endpoint as _Endpoint
from vrt_lss_fieldservice.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from vrt_lss_fieldservice.model.convert_task import ConvertTask
from vrt_lss_fieldservice.model.inline_response400 import InlineResponse400
from vrt_lss_fieldservice.model.inline_response401 import InlineResponse401
from vrt_lss_fieldservice.model.inline_response406 import InlineResponse406
from vrt_lss_fieldservice.model.inline_response415 import InlineResponse415
from vrt_lss_fieldservice.model.inline_response429 import InlineResponse429
from vrt_lss_fieldservice.model.inline_response500 import InlineResponse500
from vrt_lss_fieldservice.model.inline_response501 import InlineResponse501
from vrt_lss_fieldservice.model.inline_response502 import InlineResponse502
from vrt_lss_fieldservice.model.inline_response503 import InlineResponse503
from vrt_lss_fieldservice.model.inline_response504 import InlineResponse504
from vrt_lss_fieldservice.model.inline_response_default import InlineResponseDefault


class ConvertApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

        def __convert_to_json(
            self,
            convert_task,
            **kwargs
        ):
            """Conversion of planning task and result.  # noqa: E501

            Used for conversion of input and output data to the [Urban Delivery Json](https://docs.veeroute.com/#/udl/integration/files?id=json-import-format) format.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.convert_to_json(convert_task, async_req=True)
            >>> result = thread.get()

            Args:
                convert_task (ConvertTask): Conversion request to the JSON format.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                str
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['convert_task'] = \
                convert_task
            return self.call_with_http_info(**kwargs)

        self.convert_to_json = _Endpoint(
            settings={
                'response_type': (str,),
                'auth': [
                    'ApiKeyAuth'
                ],
                'endpoint_path': '/fieldservice/convert/json',
                'operation_id': 'convert_to_json',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'convert_task',
                ],
                'required': [
                    'convert_task',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'convert_task':
                        (ConvertTask,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'convert_task': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'text/plain',
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__convert_to_json
        )

        def __convert_to_xlsx(
            self,
            convert_task,
            **kwargs
        ):
            """Conversion of planning task and result.  # noqa: E501

            Used for conversion of input and output data to the [Urban Delivery XLSX](https://docs.veeroute.com/#/udl/integration/files?id=xlsx-import-format) format.  # noqa: E501
            This method makes a synchronous HTTP request by default. To make an
            asynchronous HTTP request, please pass async_req=True

            >>> thread = api.convert_to_xlsx(convert_task, async_req=True)
            >>> result = thread.get()

            Args:
                convert_task (ConvertTask): Conversion request to the XLSX.

            Keyword Args:
                _return_http_data_only (bool): response data without head status
                    code and headers. Default is True.
                _preload_content (bool): if False, the urllib3.HTTPResponse object
                    will be returned without reading/decoding response data.
                    Default is True.
                _request_timeout (float/tuple): timeout setting for this request. If one
                    number provided, it will be total request timeout. It can also
                    be a pair (tuple) of (connection, read) timeouts.
                    Default is None.
                _check_input_type (bool): specifies if type checking
                    should be done one the data sent to the server.
                    Default is True.
                _check_return_type (bool): specifies if type checking
                    should be done one the data received from the server.
                    Default is True.
                _host_index (int/None): specifies the index of the server
                    that we want to use.
                    Default is read from the configuration.
                async_req (bool): execute request asynchronously

            Returns:
                str
                    If the method is called asynchronously, returns the request
                    thread.
            """
            kwargs['async_req'] = kwargs.get(
                'async_req', False
            )
            kwargs['_return_http_data_only'] = kwargs.get(
                '_return_http_data_only', True
            )
            kwargs['_preload_content'] = kwargs.get(
                '_preload_content', True
            )
            kwargs['_request_timeout'] = kwargs.get(
                '_request_timeout', None
            )
            kwargs['_check_input_type'] = kwargs.get(
                '_check_input_type', True
            )
            kwargs['_check_return_type'] = kwargs.get(
                '_check_return_type', True
            )
            kwargs['_host_index'] = kwargs.get('_host_index')
            kwargs['convert_task'] = \
                convert_task
            return self.call_with_http_info(**kwargs)

        self.convert_to_xlsx = _Endpoint(
            settings={
                'response_type': (str,),
                'auth': [
                    'ApiKeyAuth'
                ],
                'endpoint_path': '/fieldservice/convert/xlsx',
                'operation_id': 'convert_to_xlsx',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'convert_task',
                ],
                'required': [
                    'convert_task',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'convert_task':
                        (ConvertTask,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'convert_task': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/octet-stream',
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client,
            callable=__convert_to_xlsx
        )
