"""
    Veeroute.LSS Field Service Engineers

    Veeroute.LSS Field Service Engineers API  # noqa: E501

    The version of the OpenAPI document: 3.8.168672
    Contact: support@veeroute.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from vrt_lss_fieldservice.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
)

def lazy_import():
    from vrt_lss_fieldservice.model.time_window import TimeWindow
    globals()['TimeWindow'] = TimeWindow


class Measurements(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
        ('driving_time',): {
            'inclusive_minimum': 0,
        },
        ('waiting_time',): {
            'inclusive_minimum': 0,
        },
        ('working_time',): {
            'inclusive_minimum': 0,
        },
        ('arriving_time',): {
            'inclusive_minimum': 0,
        },
        ('departure_time',): {
            'inclusive_minimum': 0,
        },
        ('total_time',): {
            'inclusive_minimum': 0,
        },
        ('distance',): {
            'inclusive_minimum': 0,
        },
    }

    additional_properties_type = None

    _nullable = True

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'driving_time': (int,),  # noqa: E501
            'waiting_time': (int,),  # noqa: E501
            'working_time': (int,),  # noqa: E501
            'arriving_time': (int,),  # noqa: E501
            'departure_time': (int,),  # noqa: E501
            'total_time': (int,),  # noqa: E501
            'distance': (int,),  # noqa: E501
            'time_window': (TimeWindow,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'driving_time': 'driving_time',  # noqa: E501
        'waiting_time': 'waiting_time',  # noqa: E501
        'working_time': 'working_time',  # noqa: E501
        'arriving_time': 'arriving_time',  # noqa: E501
        'departure_time': 'departure_time',  # noqa: E501
        'total_time': 'total_time',  # noqa: E501
        'distance': 'distance',  # noqa: E501
        'time_window': 'time_window',  # noqa: E501
    }

    _composed_schemas = {}

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, driving_time, waiting_time, working_time, arriving_time, departure_time, total_time, distance, *args, **kwargs):  # noqa: E501
        """Measurements - a model defined in OpenAPI

        Args:
            driving_time (int): Driving time, in minutes. For a stop, the driving time from the previous stop to the current location. 
            waiting_time (int): Total waiting time for all locations, in minutes. For a stop, the waiting time for work to be completed at the location, in minutes. 
            working_time (int): The total work completion time at all locations assigned to the trip. For a stop - the time spent on actual work completion at the location. 
            arriving_time (int): Total time spent on driving up/parking at the locations, in minutes. For a stop - the time spent on driving up/parking at the location. 
            departure_time (int): Total time to leave the locations. For a stop - the time spent on departure from the location. 
            total_time (int): Total stop/trip time/total number of trips, in minutes.        It consists of `driving_time` + `waiting_time` + `working_time` + `arriving_time` + `departure_time`.  
            distance (int): The total length of the trip / set of trips, in meters. For a stop, the distance from the previous stop to the current location. 

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            time_window (TimeWindow): [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.driving_time = driving_time
        self.waiting_time = waiting_time
        self.working_time = working_time
        self.arriving_time = arriving_time
        self.departure_time = departure_time
        self.total_time = total_time
        self.distance = distance
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
